import { DB, DBConnectorModel } from '@yeeti/modules-db';

/**
 * Interface - DB Model
 */
interface DBModelInterface {
  /**
   * Database
   */
  db: DB;

  /**
   * Model
   */
  client: DBConnectorModel;

  /**
   * Model name (defaulted to contructor.name)
   */
  name(): String;
  /**
   * Dictionary of Model properties
   */
  properties(): { [key: string]: any };
  /**
   * List of indexes
   */
  indexes(): Array<{ [key: string]: 1 | -1 }>;
}
