import { DB, DBConnectorModel } from '@yeeti/modules-db';
import { DBModelInterface } from '.';
export declare class DBModel implements DBModelInterface {
    /**
     * Database instance
     */
    db: DB;
    /**
     * Model client (mongoose.connect().model result)
     */
    client: DBConnectorModel;
    /**
     * Initialize DB Model
     * @param db Databse Instance
     */
    constructor(db: DB);
    /**
     * Model name (defaulted to contructor.name)
     */
    name(): string;
    /**
     * Dictionary of Model properties
     */
    properties(): {
        [key: string]: any;
    };
    /**
     * List of indexes
     */
    indexes(): Array<{
        [key: string]: 1 | -1;
    }>;
    /**
     * Attach current model to DB instance
     */
    attachToDB(): any;
}
//# sourceMappingURL=db-model.d.ts.map