"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DBModel {
    /**
     * Initialize DB Model
     * @param db Databse Instance
     */
    constructor(db) {
        this.db = db;
        this.client = this.attachToDB();
    }
    /**
     * Model name (defaulted to contructor.name)
     */
    name() {
        return this.constructor.name;
    }
    /**
     * Dictionary of Model properties
     */
    properties() {
        return {};
    }
    /**
     * List of indexes
     */
    indexes() {
        return [];
    }
    /**
     * Attach current model to DB instance
     */
    attachToDB() {
        const { db, client } = this;
        if (client) {
            throw new Error('Already attached to DB');
        }
        const name = this.name();
        const properties = this.properties();
        const indexes = this.indexes();
        return db.attachModel(name, properties, indexes);
    }
}
exports.DBModel = DBModel;
//# sourceMappingURL=db-model.js.map